"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const json_1 = require("../../../json");
const ServiceClient_1 = require("../../JSONRPC11/ServiceClient");
const groups_json_1 = __importDefault(require("./data/groups/groups.json"));
const schemas_json_1 = __importDefault(require("./data/schemas/schemas.json"));
const groups = groups_json_1.default;
const schemas = schemas_json_1.default;
const schemasMap = schemas.reduce((m, schema) => {
    m[schema.kbase.sample.key] = schema;
    return m;
}, {});
class SampleServiceClient extends ServiceClient_1.ServiceClient {
    constructor() {
        super(...arguments);
        this.module = 'SampleService';
    }
    status() {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield this.callFunc('status', []);
            return result;
        });
    }
    get_sample(params) {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = (yield this.callFunc('get_sample', [(0, json_1.objectToJSONObject)(params)]));
            return result;
        });
    }
    get_data_links_from_sample(params) {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield this.callFunc('get_data_links_from_sample', [(0, json_1.objectToJSONObject)(params)]);
            return result;
        });
    }
    get_metadata_key_static_metadata(params) {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield this.callFunc('get_metadata_key_static_metadata', [params]);
            return result;
        });
    }
    get_sample_acls(params) {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield this.callFunc('get_sample_acls', [params]);
            return result;
        });
    }
    create_data_link(params) {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield this.callFunc('create_data_link', [(0, json_1.objectToJSONObject)(params)]);
            return result;
        });
    }
    expire_data_link(params) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.callFuncEmptyResult('expire_data_link', [
                (0, json_1.objectToJSONObject)(params),
            ]);
        });
    }
    get_field_definitions(params) {
        return Promise.resolve({
            fields: params.keys.map((key) => {
                if (key in schemasMap) {
                    return schemasMap[key];
                }
                else {
                    throw new Error(`Field key ${key} not found`);
                }
            }),
        });
    }
    get_field_groups() {
        return Promise.resolve({
            groups,
        });
    }
}
exports.default = SampleServiceClient;
//# sourceMappingURL=client.js.map